﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CustomComboBoxCellType_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            MyComboType mct = new MyComboType(fpSpread1);
            mct.Items = (new String[] {"January", "February", "March", "April", "May", "June"});
            mct.DropDownOptions = FarPoint.Win.DropDownOptions.Button;
            fpSpread1.ActiveSheet.Cells[1, 1].CellType = mct;

        }
    }
    public class MyComboType : FarPoint.Win.Spread.CellType.ComboBoxCellType
    {

        private FarPoint.Win.Spread.FpSpread ss = null;



        public MyComboType(FarPoint.Win.Spread.FpSpread ss) { this.ss = ss; }



        public override void StartEditing(EventArgs e, bool selectAll, bool autoClipboard)
        {

            Rectangle rc = ss.GetCellRectangle(ss.GetActiveRowViewportIndex(), ss.GetActiveColumnViewportIndex(), ss.ActiveSheet.ActiveRowIndex, ss.ActiveSheet.ActiveColumnIndex);



            MouseEventArgs me = e as MouseEventArgs;

            if (me != null)
            {

                Rectangle rectButton;

                rectButton = new Rectangle(rc.X + rc.Width - 14, rc.Y, 14, rc.Height);



                if (!rectButton.Contains(new Point(((MouseEventArgs)e).X, ((MouseEventArgs)e).Y)))
                {

                    // don't drop the list

                    return;

                }

            }

            else
            {

                // start editing with "enter" key

                if (e == null)
                {

                    me = new MouseEventArgs(MouseButtons.Left, 1, rc.X + 1, rc.Y + 1, 0);

                    base.StartEditing(me, selectAll, autoClipboard);

                    return;

                }

            }



            base.StartEditing(e, selectAll, autoClipboard);

        }

    }
}
